﻿// Radio Energy Zürich 
// Google Desktop Gadget
//
// developed by Andreas Horlacher - horiworld.com



var trials=0;
var write_trials=0;
var gdgtControllerTrials=0;
var FLASH_ACTION=""; // from flash the _global.gdgt_action
var SETTING_AUTOPLAY="play"; // play / stop
var SETTING_STARTINGCHANNEL=0; // -> channellist
var SETUP_SUCCESS=false;
var oNRJ=null; // flash object
var nrjplayer=null; // gd object
var GWIDTH=110;
var GHEIGHT=210;
var Img_bt,Img_bb,Img_bl,Img_br,Img_lt,Img_rt,Img_lb,Img_rb=null;

var xmlContainer ="<div name='container' x='11' y='11' width='110' height='210' />";

var xmlNRJPlayer = "<object name=\"nrjplayer\"  classid=\"progid:ShockwaveFlash.ShockwaveFlash\" x=\"0\" y=\"0\" width=\"110\" height=\"210\" > "+
			"<param autoplay=\"true\" wmode=\"transparent\" name=\"movie\" value=\"http://media.energyzueri.com/energyradio/radio_gadget.swf\" /> "+
			"</object>";

var xmlImg_bt=	"<img name=\"border_top\" src=\"stock_images\horizontal.png\" x=\"12\" y=\"1\" width=\"110\" height=\"11\" />";
var xmlImg_bb=	"<img name=\"border_bottom\" src=\"stock_images\bhorizontal.png\" x=\"12\" y=\"215\" width=\"110\" height=\"11\" />";
var xmlImg_bl="<img name=\"border_left\" src=\"stock_images\vertikal.png\" x=\"1\" y=\"12\" width=\"11\" height=\"203\" />";
var xmlImg_br="<img name=\"border_right\" src=\"stock_images\rvertikal.png\" x=\"121\" y=\"12\" width=\"11\" height=\"203\" />";
var xmlImg_lt="<img name=\"border_lt\" src=\"stock_images\lt.png\" x=\"1\" y=\"1\" width=\"11\" height=\"11\" />";
var xmlImg_rt="<img name=\"border_rt\" src=\"stock_images\rt.png\" x=\"121\" y=\"1\" width=\"11\" height=\"11\" />";
var xmlImg_lb="<img name=\"border_lb\" src=\"stock_images\lb.png\" x=\"1\" y=\"215\" width=\"11\" height=\"11\" />";
var xmlImg_rb="<img name=\"border_rb\" src=\"stock_images\rb.png\" x=\"121\" y=\"215\" width=\"11\" height=\"11\" />";

			/*
 			"<img name=\"border_top\" src=\"stock_images\horizontal.png\" x=\"12\" y=\"1\" width=\"110\" height=\"11\" />"+
			"<img name=\"border_bottom\" src=\"stock_images\bhorizontal.png\" x=\"12\" y=\"215\" width=\"110\" height=\"11\" />"+
			" <img name=\"border_left\" src=\"stock_images\vertikal.png\" x=\"1\" y=\"12\" width=\"11\" height=\"203\" />"+
			"<img name=\"border_right\" src=\"stock_images\rvertikal.png\" x=\"121\" y=\"12\" width=\"11\" height=\"203\" />"+
			"<img name=\"border_lt\" src=\"stock_images\lt.png\" x=\"1\" y=\"1\" width=\"11\" height=\"11\" />"+
			"<img name=\"border_rt\" src=\"stock_images\rt.png\" x=\"121\" y=\"1\" width=\"11\" height=\"11\" />"+
			"<img name=\"border_lb\" src=\"stock_images\lb.png\" x=\"1\" y=\"215\" width=\"11\" height=\"11\" />"+
			"<img name=\"border_rb\" src=\"stock_images\rb.png\" x=\"121\" y=\"215\" width=\"11\" height=\"11\" />";
*/


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


function toInt ( x ) { return ( x > 0 ? Math.floor( x ) : Math.ceil ( x ) ) } // Returns an integer 


function view_onDock() {
	init_view();


}

function view_onUnDock() {
	init_view();
}

function init_view() {
	view.resizeTo(132,232);
	container.removeAllElements();
	nrjplayer = container.appendElement(xmlNRJPlayer);
}


//--------------------------------------------
function view_onOpen() {

	init_view();
	
	if ( options.getValue("gdgt_startingchannel") == "" ) { // first time
		options.putValue("gdgt_startingchannel", SETTING_STARTINGCHANNEL);
		options.putValue("gdgt_autoplay", SETTING_AUTOPLAY);
	} else {
		SETTING_AUTOPLAY = options.getValue("gdgt_autoplay");
		SETTING_STARTINGCHANNEL = options.getValue("gdgt_startingchannel");
		};
	
	setTimeout(write_setup, 1);
	view_onSize();
	setTimeout(function(){setInterval(gdgtController,2000)},1000);
}

//--------------------------------------------
function gdgtController() {
	var nrjplayer=container.children("nrjplayer");
	var oRadio=nrjplayer.object; // nrjplayer.object;

	if (oRadio==null) { // creation of object failed
		debug.trace("oRadio==null");
		edTester.value="null";
		// alert("Fehler bei Flash - Initialisierung: bitte neueste Version downloaden bei www.adobe.com");
		};
	
	try {
		FLASH_ACTION = oRadio.getVariable("gdgt_action");
	}catch(ex) { 
		debug.trace("***failed"); FLASH_ACTION="FAILURE"; 
		};

	debug.trace("cont:"+FLASH_ACTION);
	edTester.value="cont:"+FLASH_ACTION;

	if ( FLASH_ACTION=="setup") {
		debug.trace("****************************************************SETUP");
		edTester.value="setup() called now";
		try { oRadio.setVariable("gdgt_action","nothing")}catch(ex) { debug.trace("failed.")};
		// alert("here setup");
		setup();
		
		try { FLASH_ACTION = oRadio.getVariable("gdgt_action")}catch(ex) { debug.trace("failed") };
		debug.trace("cont2:"+FLASH_ACTION);
		};
	
}

//--------------------------------------------
function view_onSize() {
	debug.trace("size "+view.height+"/"+view.width);
	view.resizeTo(132,232);
}



function read_setup() {
	var nrjplayer=container.children("nrjplayer");
	var oNRJ=nrjplayer.object; // nrjplayer.object;
	
	try {
		SETTING_AUTOPLAY = oNRJ.getVariable("gdgt_autoplay");
		SETTING_STARTINGCHANNEL = oNRJ.getVariable("gdgt_startingchannel");
		SETUP_SUCCESS = true;
		trials=999;
		debug.trace("ok  "+oNRJ.getVariable("gdgt_action"));
		lblcheck.innerText=SETTING_AUTOPLAY+"     "+channellist[SETTING_STARTINGCHANNEL]+"->"+SETTING_STARTINGCHANNEL;

	} catch(ex) {
		if ( trials != 999) {
			SETUP_SUCCESS=false;
			if ( trials <= 100 ) {
				setTimeout(read_setup, 100);
				++trials;
				debug.trace("try read_setup "+trials);
			} else {
				debug.trace("100 trials reached - no results");
				alert("ERROR READING SETTINGS");
				trials=0;
				};
			};
		};
}

function write_setup() {
	var nrjplayer=container.children("nrjplayer");
	var oNRJ=nrjplayer.object;
	try {
		oNRJ.setVariable("gdgt_autoplay", SETTING_AUTOPLAY);
		oNRJ.setVariable("gdgt_startingchannel", SETTING_STARTINGCHANNEL);
		write_trials=0;
		read_setup();
	} catch(ex) {
		SETUP_SUCCESS=false;
		if (write_trials <= 100 ) {
			setTimeout(write_setup, 100);
			++write_trials;
			debug.trace("try write_setup "+write_trials);
		} else {
			debug.trace("100 trials reached - no results");
			write_trials=0;
			};
		};
}


function go() {
	// show_setup();
	pluginHelper.showOptionsDialog();
}


function setup() {
	read_setup();
	pluginHelper.showOptionsDialog();
}




